<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_hotelRatePlanCancellationPolicy ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_hotelRatePlanCancellationPolicy extends AbstractStructArrayBase
{
    /**
     * The CancellationPolicy
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_hotelRatePlanCancellationPolicy[]
     */
    public $CancellationPolicy;
    /**
     * Constructor method for ArrayOfJPSOAP_hotelRatePlanCancellationPolicy
     * @uses ArrayOfJPSOAP_hotelRatePlanCancellationPolicy::setCancellationPolicy()
     * @param \StructType\JPSOAP_hotelRatePlanCancellationPolicy[] $cancellationPolicy
     */
    public function __construct(array $cancellationPolicy = array())
    {
        $this
            ->setCancellationPolicy($cancellationPolicy);
    }
    /**
     * Get CancellationPolicy value
     * @return \StructType\JPSOAP_hotelRatePlanCancellationPolicy[]|null
     */
    public function getCancellationPolicy()
    {
        return $this->CancellationPolicy;
    }
    /**
     * Set CancellationPolicy value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_hotelRatePlanCancellationPolicy[] $cancellationPolicy
     * @return \ArrayType\ArrayOfJPSOAP_hotelRatePlanCancellationPolicy
     */
    public function setCancellationPolicy(array $cancellationPolicy = array())
    {
        foreach ($cancellationPolicy as $arrayOfJPSOAP_hotelRatePlanCancellationPolicyCancellationPolicyItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_hotelRatePlanCancellationPolicyCancellationPolicyItem instanceof \StructType\JPSOAP_hotelRatePlanCancellationPolicy) {
                throw new \InvalidArgumentException(sprintf('The CancellationPolicy property can only contain items of \StructType\JPSOAP_hotelRatePlanCancellationPolicy, "%s" given', is_object($arrayOfJPSOAP_hotelRatePlanCancellationPolicyCancellationPolicyItem) ? get_class($arrayOfJPSOAP_hotelRatePlanCancellationPolicyCancellationPolicyItem) : gettype($arrayOfJPSOAP_hotelRatePlanCancellationPolicyCancellationPolicyItem)), __LINE__);
            }
        }
        $this->CancellationPolicy = $cancellationPolicy;
        return $this;
    }
    /**
     * Add item to CancellationPolicy value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_hotelRatePlanCancellationPolicy $item
     * @return \ArrayType\ArrayOfJPSOAP_hotelRatePlanCancellationPolicy
     */
    public function addToCancellationPolicy(\StructType\JPSOAP_hotelRatePlanCancellationPolicy $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_hotelRatePlanCancellationPolicy) {
            throw new \InvalidArgumentException(sprintf('The CancellationPolicy property can only contain items of \StructType\JPSOAP_hotelRatePlanCancellationPolicy, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CancellationPolicy[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_hotelRatePlanCancellationPolicy|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_hotelRatePlanCancellationPolicy|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_hotelRatePlanCancellationPolicy|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_hotelRatePlanCancellationPolicy|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_hotelRatePlanCancellationPolicy|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CancellationPolicy
     */
    public function getAttributeName()
    {
        return 'CancellationPolicy';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJPSOAP_hotelRatePlanCancellationPolicy
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
